//Code made by Bauklotz (2107) and McTwist (9845) with Demian (10334) poking around (Snooping around as an apprentice of the Senseis, doing some commenting and RTB prefs.)

function healthKitPickup(%this, %obj, %col, %respawn)
{
	if(%obj.respawning || (%dmg = %col.getDamageLevel()) <= 0)
		return;
	%health = ($Pref::TF2S::Percentage) ? %col.getDataBlock().maxDamage * %this.healScale : %this.healScale;
	%col.addHealth(%health);
	%obj.fadeOut();
	%obj.respawning = true;
	%obj.schedule(%respawn, fadeInSchedule);
}

function Item::spinTF2S(%obj)
{
	%obj.rotate = $Pref::TF2S::Spin; //Enable/Disable spinning.
}

//Spin speed and rotation is built in an cannot be changed.
function Item::fadeInSchedule(%obj)
{
	%obj.respawning = false;
	%obj.fadeIn();
}

function healthHeartItem::onAdd(%this, %obj)
{
	%obj.spinTF2S();
}

function healthPillItem::onAdd(%this, %obj)
{
	%obj.spinTF2S();
}

function healthPlusItem::onAdd(%this, %obj)
{
	%obj.spinTF2S();
}

function healthHeartItem::onPickup(%this, %obj, %col)
{ 
	healthKitPickup(%this, %obj, %col, $Pref::HealthP::RespawnHeart);
}

function healthPillItem::onPickup(%this, %obj, %col)
{
	healthKitPickup(%this, %obj, %col, $Pref::HealthP::RespawnPill);
}

function healthPlusItem::onPickup(%this, %obj, %col)
{
	healthKitPickup(%this, %obj, %col, $Pref::HealthP::RespawnPlus);
}

datablock itemData(healthHeartItem : printGun)
{
	image = "";
	uiName = "Health Pickup, Heart";
	healScale = ($Pref::TF2S::Percentage) ? $Pref::HealthP::HealHeart / 100 : $Pref::HealthP::HealHeart ;
	shapeFile = "./heart.dts";
};

datablock itemData(healthPillItem : printGun)
{
	image = "";
	uiName = "Health Pickup, Pill";
	healScale = ($Pref::TF2S::Percentage) ? $Pref::HealthP::HealPill / 100 : $Pref::HealthP::HealPill;
	shapeFile = "./pill.dts";
};

datablock itemData(healthPlusItem : printGun)
{
	image = "";
	uiName = "Health Pickup, Plus";
	healScale = ($Pref::TF2S::Percentage) ? $Pref::HealthP::HealPlus / 100 : $Pref::HealthP::HealPlus;
	shapeFile = "./plus.dts";
};